﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;

namespace Win32
{
    class Api
    {
        public const int SRCCOPY = 0x00CC0020;
        
        public const int WM_LBUTTONDOWN = 513;
        public const int WM_RBUTTONDOWN = 516;
        public const int WM_KEYDOWN = 256;
        public const int WM_MOUSEMOVE = 512;

        public const int VK_HOME = 36;
        public const int VK_END = 35;
        public const int VK_PRIOR = 33;
        public const int VK_NEXT = 34;
        public const int VK_LEFT = 37;
        public const int VK_UP = 38;
        public const int VK_RIGHT = 39;
        public const int VK_DOWN = 40;

        public const int VK_NUMPAD1 = 97;
        public const int VK_NUMPAD2 = 98;
        public const int VK_NUMPAD3 = 99;
        public const int VK_NUMPAD4 = 100;
        public const int VK_NUMPAD5 = 101;
        public const int VK_NUMPAD6 = 102;
        public const int VK_NUMPAD7 = 103;
        public const int VK_NUMPAD8 = 104;
        public const int VK_NUMPAD9 = 105;

        public const int BM_GETCHECK = 0xF0;
        public const int GWL_ID = -12;

        private const string User32 = @"user32.dll";
        private const string GDI32 = @"gdi32.dll";
        private const string Kernel32 = @"kernel32.dll";

        // Emulate standard Win32 RGB function
        public static int RGB(byte R, byte G, byte B) { return ((B * 256) + G) * 256 + R; }
        public static int ARGB(byte A, byte R, byte G, byte B) { return (((A * 256) + R) * 256 + G) * 256 + B; }
        public static int LoWrd(uint value) { return (int)(value & 0xFFFF); }
        public static int HiWrd(uint value) { return (int)(value >> 16); }

        public struct RECT { public int left, top, right, bottom;}
        [DllImport(User32)]
        public static extern bool GetClientRect(IntPtr hWnd, ref RECT rc);

        [DllImport(GDI32)]  // Win32 encapsulation
        public static extern bool DeleteObject(IntPtr hObject);

        [DllImport(User32)] // Win32 encapsulation
        public static extern IntPtr GetDesktopWindow();

        [DllImport(User32)] // Win32 encapsulation
        public static extern int GetWindowDC(IntPtr hWnd);

        [DllImport(User32)] // Win32 encapsulation
        public static extern int ReleaseDC(IntPtr hWnd, int DC);

        [DllImport(GDI32)]  // Win32 encapsulation
        public static extern int BitBlt(
        int hDCDest, int xDest, int yDest, int Width, int Heifght,
        int hDCSrce, int xSrce, int ySrce, int CopyMode
        );

        [DllImport(User32)] // Win32 encapsulation
        public static extern IntPtr GetDlgItem(IntPtr hCtrl, int DlgItem);

        [DllImport(User32)] // Win32 encapsulation
        public static extern void MoveWindow(IntPtr hCtrl, int X, int Y, int W, int H, int Flag);

        [DllImport(User32, EntryPoint = "GetWindowLongA")]
        public static extern int GetWindowLong(IntPtr hWnd, int nIndex);

        [DllImport(User32, EntryPoint = "SetWindowLongA")]
        public static extern int SetWindowLong(IntPtr hWnd, int nIndex, int nNewLong);

        [DllImport(User32, EntryPoint = "SendMessageA")]
        public static extern int SendMessage(IntPtr hWnd, uint dwMsg, uint wParam, int lParam);

        [DllImport(User32, EntryPoint = "SetWindowTextA")]
        public static extern int SetWindowText(IntPtr hWnd, string lpString);

        [DllImport(User32)]
        public static extern int GetDlgCtrlID(IntPtr hWnd);

        [DllImport(User32)]
        public static extern IntPtr SetFocus(IntPtr hWnd);

    }
}
